--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Bit random initialise component
--
-- Author  Matthew Caryl
-- Created 20.12.96
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation;
with Mutants.Core.Random;
use Mutants.Core.Selector;
use Mutants.Core.Representation;
use Mutants.Core.Random;

package Mutants.Core.Creator.Bit_Random_Initialise is

	type Bit_Random_Initialise(Random : Random_Access) is new Mutants.Core.Creator.Creator with private;

        procedure Create(Creator : in out Bit_Random_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	-- SIMILAR THING BUT WITH HISTORY
	procedure Selector(Creator : in out Bit_Random_Initialise; Sel : Selector_Access; Required : out Boolean);
	
private

	type Bit_Random_Initialise(Random : Random_Access) is new Mutants.Core.Creator.Creator with
		record
			Chance : Random_Access := Random;
		end record;

	function Parents(Creator : in Bit_Random_Initialise) return Natural;
	procedure Breed(Creator : in out Bit_Random_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Core.Creator.Bit_Random_Initialise;
