--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Vector random initialise component
--
-- Author  Matthew Caryl
-- Created 16.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Vector;
use Mutants.Core.Selector;
use Mutants.Core.Representation;

generic
	with package Vector_Package is new Mutants.Core.Representation.Vector(<>);

package Mutants.Core.Creator.Vector_Initialise is

	type Vector_Initialise(Init : Creator_Access; Size : Natural) is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Vector_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Vector_Initialise; Sel : Selector_Access; Required : out Boolean);

private
	
	type Vector_Initialise(Init : Creator_Access; Size : Natural) is new Mutants.Core.Creator.Creator with
		record
			Initer : Creator_Access := Init;
			Maximum : Natural := Size;
		end record;
	
	function Parents(Creator : in Vector_Initialise) return Natural;
	procedure Breed(Creator : in out Vector_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);
	
end Mutants.Core.Creator.Vector_Initialise;
