--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Representation component
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

package body Mutants.Core.Representation.Bit is

	function Equal(one, two : Bit_Representation) return Boolean is
	begin
		return one.Representation = two.Representation;
	end Equal;
	
	function Get(Representation : in Bit_Representation) return Boolean is
	begin
		return Representation.Representation;
	end Get;

	procedure Set(Representation : out Bit_Representation; Bit : Boolean) is
	begin
		Representation.Representation := Bit;
	end Set;

	function Get(Representation : in Bit_Representation_Access) return Boolean is
	begin
		return Get(Representation.all);
	end Get;

	procedure Set(Representation : in Bit_Representation_Access; Bit : Boolean) is
	begin
		Set(Representation.all, Bit);
	end Set;

end Mutants.Core.Representation.Bit;
