--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit -  Integer representation component
--
-- Author  Matthew Caryl
-- Created 4.2.97
--

package body Mutants.Core.Representation.Integer is

 	function Equal(one, two : Integer_Representation) return Boolean is
 	begin
 		return one = two;
 	end Equal;
 
 	function Get(Rep : in Integer_Representation) return Standard.Integer is
	begin
		return Rep.Rep;
	end Get;

	procedure Set(Rep : out Integer_Representation; Int : Standard.Integer) is
	begin
		Rep.Rep := Int;
	end Set;

	function Get(Rep : in Integer_Representation_Access) return Standard.Integer is
	begin
		return Get(Rep.all);
	end Get;

	procedure Set(Rep : in Integer_Representation_Access; Int : Standard.Integer) is
	begin
		Set(Rep.all, Int);
	end Set;

end Mutants.Core.Representation.Integer;
