--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Order random initialise component
--
-- Author  Matthew Caryl
-- Created 4.2.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Individual;
use Mutants.Core.Population;

package body Mutants.Core.Creator.Order_Initialise is

	use Order_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Order_Representation, Order_Representation_Access);

	use Order_Package;
	procedure Create(Creator : in out Order_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		o : Order_Representation_Access;
		e : Element_Type_Access;
		rs : Representation_Access_Array(1..1);
		r : Representation_Access;
		success : Boolean;
	begin
		o := new Order_Representation(Creator.Maximum);
		-- create population
		for j in 1..Size loop
			-- create each element
			for k in 1..Creator.Maximum loop
				-- breed element
				Breed(Creator.Initer.all, rs, r, success);
				-- set element into order
				Set(o, k, Element_Type_Access(r).all);
			end loop;
			-- create individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(o));
			-- add to population
			Add(Pop, i);
		end loop;
		Free(o);
	end Create;

	procedure Selector(Creator : in out Order_Initialise; Sel : Selector_Access; Required : out Boolean) is
	begin
		Selector(Creator.Initer.all, Sel, Required);
	end Selector;

	function Parents(Creator : in Order_Initialise) return Natural is
	begin
		return Parents(Creator.Initer.all);
	end Parents;
	
	use Order_Package;
        procedure Breed(Creator : in out Order_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		s : Integer := Parents(Creator);
		b : Representation_Access;
		r : Representation_Access_Array(1..s);
		bo : Order_Representation_Access;
		e : Element_Type_Access;
		o : Order_Representation_Access;
	begin
		bo := new Order_Representation(Creator.Maximum);
		for k in 1..Creator.Maximum loop	
			for i in 1..s loop
				o := Order_Representation_Access(Reps_In(i));
				Get(o, k, e);
				r(i) := Representation_Access(e);
			end loop;
			Breed(Creator.Initer.all, r, b, Success);
			Set(bo, k, Element_Type(b.all));
		end loop;
		Rep_Out := Representation_Access(bo);
	end Breed;
	
end Mutants.Core.Creator.Order_Initialise;
