--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Order random initialise component
--
-- Author  Matthew Caryl
-- Created 4.2.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Order;
use Mutants.Core.Selector;
use Mutants.Core.Representation;

generic
	with package Order_Package is new Mutants.Core.Representation.Order(<>);

package Mutants.Core.Creator.Order_Initialise is

	type Order_Initialise(Init : Creator_Class_Access; Size : Natural) is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Order_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Order_Initialise; Sel : Selector_Access; Required : out Boolean);

private
	
	type Order_Initialise(Init : Creator_Class_Access; Size : Natural) is new Mutants.Core.Creator.Creator with
		record
			Initer : Creator_Class_Access := Init;
			Maximum : Natural := Size;
		end record;
	
	function Parents(Creator : in Order_Initialise) return Natural;
	procedure Breed(Creator : in out Order_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);
	
end Mutants.Core.Creator.Order_Initialise;
