-- A matrix object
--
-- Author	Matthew Caryl
-- Created	18.11.96

package body Matrix is
	procedure Put(matrix : in out Matrix; value : Float; x, y : Integer) is
	begin
		matrix.matrix(x, y) := value;
	end Put;

	function Get(matrix : in Matrix; x, y : Integer) return Float is
	begin
		return matrix.matrix(x, y);
	end Get;

	function Width(matrix : in Matrix) return Integer is
	begin
		return matrix.matrix'Last(1) - matrix.matrix'First(1) + 1;
	end Width;

	function Height(matrix : in Matrix) return Integer is
	begin
		return matrix.matrix'last(2) - matrix.matrix'First(2) + 1;
	end Height;
end Matrix;
