--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Test harness for Count_Ending
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

with Ada.Text_IO;
with Ada.Text_IO.Integer_IO;
with Mutants.Core.Ending.Count;
with Mutants.Core.Ending.Time;
use Ada.Text_IO;
use Mutants.Core.Ending;
use Mutants.Core.Ending.Count;
use Mutants.Core.Ending.Time;

procedure EndingTest is
	procedure Output(e : in out Ending'Class) is
		package Integer_IO is new Ada.Text_IO.Integer_IO(Integer);
		i : Integer;
		d : Boolean;
	begin
		i := 1;
		Put_Line("start");
		Done(e, d);
		while not d loop
			Integer_IO.Put(i);
			New_Line;
			i := i + 1;
			Done(e, d);
		end loop;
	end Output;
	
	c : Count_Ending;
	t : Time_Ending;
begin
	Reset(t, 1.0);
	Output(t);
	Reset(c, 10);
	Output(c);
end;
