--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Test harness for Individual component
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

with Ada.Text_IO.Enumeration_IO;
with Ada.Text_IO.Float_IO;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Individual;
use Ada.Text_IO;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Individual;

procedure IndividualTest is
	package Boolean_IO is new Ada.Text_IO.Enumeration_IO(Boolean);
	package Float_IO is new Ada.Text_IO.Float_IO(Float);

	r : aliased Bit_Representation;
	i : Individual(r'Unchecked_Access);
	z : Bit_Representation_Access;
begin
	z := Bit_Representation_Access(Representation(i));
	Boolean_IO.Put(Get(z));
	New_Line;
	Set(z, true);
	Boolean_IO.Put(Get(z));
	New_Line;
	Evaluation(i, 22.0);
	Float_IO.Put(Evaluation(i));
	New_Line;
end IndividualTest;
