--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Creator component
--
-- Author  Matthew Caryl
-- Created 20.12.96
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector, Mutants.Core.Population, Mutants.Core.Representation;
use Mutants.Core.Selector, Mutants.Core.Representation;

package Mutants.Core.Creator is

	type Creator is abstract tagged private;
	subtype Creator_Class is Creator'Class;
	type Creator_Access is access all Creator'Class;

        procedure Create(Creator : in out Creator; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is abstract;
	procedure Selector(Creator : in out Creator; Sel : Selector_Access; Required : out Boolean) is abstract;
	
private

	type Creator is abstract tagged null record;

	function Parents(Creator : in Creator) return Natural is abstract;
	procedure Breed(Creator : in out Creator; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is abstract;

end Mutants.Core.Creator;
