--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Binary Bit Vector Evaluation component
--
-- Author  Matthew Caryl
-- Created 13.12.96
--

with Mutants.Core.Evaluation;
with Mutants.Core.Representation.Bit_Vector;
use Mutants.Core.Evaluation;
use Mutants.Core.Representation.Bit_Vector;

package Mutants.Core.Evaluation.Binary_Bit_Vector is

	type Binary_Bit_Vector_Evaluation is new Evaluation with private;

	function Evaluate(Evaluation : in Binary_Bit_Vector_Evaluation; Representation : in Representation_Access) return Float;

private

	type Binary_Bit_Vector_Evaluation is new Evaluation with null record;

end Mutants.Core.Evaluation.Binary_Bit_Vector;
