--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - One evaluation component
--
-- Author  Matthew Caryl
-- Created 13.2.97
--

with Mutants.Core.Representation;
use Mutants.Core.Representation;

package Mutants.Core.Evaluation.One is

	type One_Evaluation is new Evaluation with private;

	function Evaluate(Evaluation : in One_Evaluation; Representation : in Representation_Access) return Float;

private

	type One_Evaluation is new Evaluation with null record;

end Mutants.Core.Evaluation.One;
