--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Low Selector component
--
-- Author  Matthew Caryl
-- Created 6.2.97
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
use Mutants.Core.Selector;
use Mutants.Core.Individual;

package Mutants.Core.Selector.Low is

        type Low_Selector is new Selector with private;

        procedure Attach(Sel : in out Low_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class);
        procedure Get(Sel : in out Low_Selector; Individual : out Individual_Access);
        procedure Put(Sel : in out Low_Selector; Individual : in Individual_Access);

private

        type Low_Selector is new Selector with
		record
			Low_Individual : Individual_Access := null; 
		end record;

end Mutants.Core.Selector.Low;
