--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Extended Toolkit - Integer order initialise component
--
-- Author  Matthew Caryl
-- Created 5.2.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Integer;
with Mutants.Extended.Representation.Integer_Order;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Individual;
use Mutants.Core.Population;
use Mutants.Core.Representation.Integer;
use Mutants.Extended.Representation.Integer_Order;

package body Mutants.Extended.Creator.Integer_Order_Initialise is

	procedure Free is new Ada.Unchecked_Deallocation(Order_Representation, Order_Representation_Access);

	procedure Create(Creator : in out Integer_Order_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		int : Integer_Representation;
		o : Order_Representation_Access;
	begin
		o := new Order_Representation(Creator.Maximum);
		-- create each element
		for k in 1..Creator.Maximum loop
			Set(int, k);
			Set(o, k, int);
		end loop;
		-- create population
		for j in 1..Size loop
			-- create individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(o));
			-- add to population
			Add(Pop, i);
		end loop;
		Free(o);
	end Create;

	procedure Selector(Creator : in out Integer_Order_Initialise; Sel : Selector_Access; Required : out Boolean) is
	begin
		Required := false;
	end Selector;

	function Parents(Creator : in Integer_Order_Initialise) return Natural is
	begin
		return 0;
	end Parents;
	
        procedure Breed(Creator : in out Integer_Order_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		int : Integer_Representation;
		o : Order_Representation_Access;
	begin
		o := new Order_Representation(Creator.Maximum);
		-- create each element
		for k in 1..Creator.Maximum loop
			Set(int, k);
			Set(o, k, int);
		end loop;
		Rep_Out := Representation_Access(o);
	end Breed;
	
end Mutants.Extended.Creator.Integer_Order_Initialise;
